#include "testcpp.h"
#include "clock.h"
#include <cstdio>

namespace TestStandard
{
	struct VTable;

	struct TestObject
	{
		VTable * vtable;
	};

	struct VTable
	{
		void (*vcall[2])(TestObject *);
	};

	static void vcallImplementation(TestObject * object)
	{
		
	}

	static TestObject * create()
	{
		TestObject * object = new TestObject;
		object->vtable = new VTable;
		object->vtable->vcall[1] = &vcallImplementation;
		return object;
	}
}

unsigned int testStandard(unsigned testCount)
{
	using namespace TestStandard;
	
	TestObject* object = create();
	startClock();
	for (unsigned i = 0; i < testCount; ++i)
		object->vtable->vcall[1](object);
	return currentClock();
}
